from julia import Main
import julia
import os

julia.install()

current_dir = os.path.dirname(os.path.abspath(__file__))
julia_file = os.path.join(current_dir, 'microstates.jl')
Main.include(julia_file)
Microstates = Main.Microstates

def MicrostateS(Serie, Threshold, Window_Size=None, StatsBlock=2, RP_percent=0.05):
    '''
    Function to calculate the entropy and the microstates probability
    ------------------------------------------------------------------
    Serie       : Time Series to be evaluated (can be multi-dimensional)
    Threshold   : Recurrence threshold (epsilon)
    Window_Size : Number of points in data to be evaluated (if not declared it will be initialized as len(Serie)
    StatsBlock  : Size of the MicroState, matrix with size StatsBlock x StatsBlock
    RP_percent  : Percent of samples in RP to be randomly selected
    '''
     
    if Window_Size is None:
        Window_Size = len(Serie)
    return Microstates.MicrostateS(Serie, Threshold, Window_Size, StatsBlock, RP_percent)

def MS2(Serie, Threshold, Window_Size=None, StatsBlock=2, RP_percent=0.05):
    '''
    Function to calculate the entropy and the microstates probability
    ------------------------------------------------------------------
    Serie       : Time Series to be evaluated (can be multi-dimensional)
    Threshold   : Recurrence threshold (epsilon)
    Window_Size : Number of points in data to be evaluated (if not declared it will be initialized as len(Serie)
    StatsBlock  : Size of the MicroState, matrix with size StatsBlock x StatsBlock
    RP_percent  : Percent of samples in RP to be randomly selected
    '''
    if Window_Size is None:
        Window_Size = len(Serie)
    return Microstates.MS2(Serie, Threshold, Window_Size, StatsBlock, RP_percent)
